import java.io.*;
import org.jdom.*;
import org.jdom.output.*;

public class Exemple1 {
	   //on cre l'arborescence en crant la racine XML qui sera ici "personnes".
	   static Element racine = new Element("personnes");

	   //On cre un nouveau Document JDOM bas sur la racine que l'on vient de crer
	   static org.jdom.Document document = new Document(racine);

	   public static void main(String[] args) {
	      //On cre un nouvel Element etudiant et on l'ajoute
	      //en tant qu'Element de racine
	      Element etudiant = new Element("etudiant");
	      racine.addContent(etudiant);

	      //On cre un nouvel Attribut classe et on l'ajoute  etudiant
	     //grce  la mthode setAttribute
	      Attribute classe = new Attribute("classe","Licence");
	      etudiant.setAttribute(classe);

	      //On cre un nouvel Element nom, on lui assigne du texte
	      //et on l'ajoute en tant qu'Element de etudiant
	      Element nom = new Element("nom");
	      nom.setText("Daniel");
	      etudiant.addContent(nom);

	      //Les deux mthodes qui suivent seront dfinies plus loin dans l'article
	      affiche();
	      enregistre("exemple1.xml");
	   }
	   static void affiche() {
	      try {
	         //On utilise ici un affichage classique avec getPrettyFormat()
	         XMLOutputter sortie = new XMLOutputter(Format.getPrettyFormat());
	         sortie.output(document, System.out);
	      }
	      catch (java.io.IOException e){}
	   }
	   static void enregistre(String fichier) {
	      try {
	         //On utilise ici un affichage classique avec getPrettyFormat()
	         XMLOutputter sortie = new XMLOutputter(Format.getPrettyFormat());
	         //Remarquez qu'il suffit simplement de crer une instance de FileOutputStream
	         //avec en argument le nom du fichier pour effectuer la srialisation.
	         sortie.output(document, new FileOutputStream(fichier));
	      } catch (java.io.IOException e){}
	   }
}
